﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ButtonMove {
    public partial class ButtonMove : Form {
        public ButtonMove() {
            InitializeComponent();
        }

        private Boolean bMoving = false;
        private Button PressedButton = null;
        private Boolean mouseDown = false;
        private Point orgPos;
        private Point startPos;

        private void button_MouseDown(object sender, MouseEventArgs e) {
            PressedButton = (Button)sender;
            startPos = new Point(e.X, e.Y);
            orgPos = PressedButton.Location;
            mouseDown = true;
        }

        private void button_MouseUp(object sender, MouseEventArgs e) {
            mouseDown = bMoving = false;
            PressedButton = null;
        }

        private void button_MouseMove(object sender, MouseEventArgs e) {
            if (bMoving && mouseDown) {
                orgPos = PressedButton.Location = new Point(orgPos.X - startPos.X + e.X, orgPos.Y - startPos.Y + e.Y);
            }
        }

        private void button_KeyChange(object sender, KeyEventArgs e) {
            bMoving = e.Control;
        }
    }
}
